Index: unk/sources/HeuristicLab.Optimization/3.3/RunCollectionComparisonConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionComparisonConstraint.cs	(revision 3618)
+++ 	(revision )
@@ -1,126 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Optimization {
-  [StorableClass]
-  [Item("RunCollectionComparisonConstraint", "A constraint which compares the members of the contained runs with the constraint data.")]
-  public class RunCollectionComparisonConstraint : ComparisonConstraint, IRunCollectionConstraint {
-    public RunCollectionComparisonConstraint()
-      : base() {
-    }
-    [StorableConstructor]
-    protected RunCollectionComparisonConstraint(bool deserializing) {
-    }
-    public RunCollectionComparisonConstraint(RunCollection constrainedValue, ConstraintOperation constraintOperation, object constraintData)
-      : base(constrainedValue, constraintOperation, constraintData) {
-    }
-    public RunCollectionComparisonConstraint(RunCollection constrainedValue, ConstraintOperation constraintOperation, object constraintData, bool active)
-      : base(constrainedValue, constraintOperation, constraintData, active) {
-    }
-
-    public new RunCollection ConstrainedValue {
-      get { return (RunCollection)base.ConstrainedValue; }
-      set { base.ConstrainedValue = value; }
-    }
-
-    public new IStringConvertibleValue ConstraintData {
-      get { return (IStringConvertibleValue)base.ConstraintData; }
-      set {
-        if (!(value is IComparable))
-          throw new ArgumentException("Only IComparables allowed for ConstraintData");
-        base.ConstraintData = value;
-      }
-    }
-
-    [Storable]
-    private int constraintColumn;
-    public int ConstraintColumn {
-      get { return constraintColumn; }
-      set {
-        if (value < 0 || value >= ((IStringConvertibleMatrix)ConstrainedValue).ColumnNames.Count())
-          throw new ArgumentException("Could not set ConstraintData to not existing column index.");
-        if (constraintColumn != value) {
-          constraintColumn = value;
-          this.OnConstraintColumnChanged();
-        }
-      }
-    }
-
-    public event EventHandler ConstraintColumnChanged;
-    protected virtual void OnConstraintColumnChanged() {
-      EventHandler handler = ConstraintColumnChanged;
-      if (handler != null)
-        handler(this, EventArgs.Empty);
-    }
-
-    protected override bool Check(object constrainedMember) {
-      if (!Active)
-        return true;
-
-      foreach (IRun run in ConstrainedValue.Where(r => r.Visible)) {
-        IItem item = ConstrainedValue.GetValue(run, constraintColumn);
-        if (!base.Check(item))
-          run.Visible = false;
-      }
-      return true;
-    }
-
-    protected override bool Check(object constrainedMember, out string errorMessage) {
-      errorMessage = string.Empty;
-      if (!Active)
-        return true;
-
-      foreach (IRun run in ConstrainedValue.Where(r => r.Visible)) {
-        IItem item = ConstrainedValue.GetValue(run, constraintColumn);
-        if (!base.Check(item))
-          run.Visible = false;
-      }
-      return true;
-    }
-
-    public override string ToString() {
-      string s = string.Empty;
-      IStringConvertibleMatrix matrix = ConstrainedValue;
-      if (matrix != null && matrix.ColumnNames.Count() != 0)
-        s += matrix.ColumnNames.ElementAt(constraintColumn) + " ";
-      else
-        return "ComparisonConstraint";
-
-      if (ConstraintOperation != null)
-        s += ConstraintOperation.ToString() + " ";
-
-      if (ConstraintData != null)
-        s += ConstraintData.GetValue();
-      else
-        s += "null";
-
-      return s;
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Optimization/3.3/RunCollectionConstraintCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionConstraintCollection.cs	(revision 3618)
+++ 	(revision )
@@ -1,38 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Optimization {
-  [StorableClass]
-  [Item("RunCollectionConstraintCollection", "Represents a collection of constraints.")]
-  public class RunCollectionConstraintCollection : ItemCollection<IRunCollectionConstraint> {
-    public RunCollectionConstraintCollection() : base() { }
-    public RunCollectionConstraintCollection(int capacity) : base(capacity) { }
-    public RunCollectionConstraintCollection(IEnumerable<IRunCollectionConstraint> collection) : base(collection) { }
-    [StorableConstructor]
-    protected RunCollectionConstraintCollection(bool deserializing) : base(deserializing) { }
-  }
-}
Index: unk/sources/HeuristicLab.Optimization/3.3/RunCollectionEqualityConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionEqualityConstraint.cs	(revision 3618)
+++ 	(revision )
@@ -1,124 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Optimization {
-  [StorableClass]
-  [Item("RunCollectionEqualityConstraint", "A constraint which checks the members of the contained runs for equality to the constraint data.")]
-  public class RunCollectionEqualityConstraint : EqualityConstraint, IRunCollectionConstraint {
-    public RunCollectionEqualityConstraint()
-      : base() {
-      this.ConstraintData = string.Empty;
-    }
-    [StorableConstructor]
-    protected RunCollectionEqualityConstraint(bool deserializing) {
-    }
-    public RunCollectionEqualityConstraint(RunCollection constrainedValue, ConstraintOperation constraintOperation, string constraintData)
-      : base(constrainedValue, constraintOperation, constraintData) {
-    }
-    public RunCollectionEqualityConstraint(RunCollection constrainedValue, ConstraintOperation constraintOperation, string constraintData, bool active)
-      : base(constrainedValue, constraintOperation, constraintData, active) {
-    }
-
-    public new RunCollection ConstrainedValue {
-      get { return (RunCollection)base.ConstrainedValue; }
-      set { base.ConstrainedValue = value; }
-    }
-
-    public new string ConstraintData {
-      get { return (string) base.ConstraintData;}
-      set { base.ConstraintData = value;}
-    }
-
-    [Storable]
-    private int constraintColumn;
-    public int ConstraintColumn {
-      get { return constraintColumn; }
-      set {
-        if (value < 0 || value >= ((IStringConvertibleMatrix)ConstrainedValue).ColumnNames.Count())
-          throw new ArgumentException("Could not set ConstraintData to not existing column index.");
-        if (constraintColumn != value) {
-          constraintColumn = value;
-          this.OnConstraintColumnChanged();
-          this.OnToStringChanged();
-        }
-      }
-    }
-
-    public event EventHandler ConstraintColumnChanged;
-    protected virtual void OnConstraintColumnChanged() {
-      EventHandler handler = ConstraintColumnChanged;
-      if (handler != null)
-        handler(this, EventArgs.Empty);
-    }
-
-    protected override bool Check(object constrainedMember) {
-      if (!Active)
-        return true;
-
-      foreach (IRun run in ConstrainedValue.Where(r => r.Visible)) {
-        IItem item = ConstrainedValue.GetValue(run, constraintColumn);
-        if (!base.Check(item.ToString()))
-          run.Visible = false;
-      }
-      return true;
-    }
-
-    protected override bool Check(object constrainedMember, out string errorMessage) {
-      errorMessage = string.Empty;
-      if (!Active)
-        return true;
-
-      foreach (IRun run in ConstrainedValue.Where(r => r.Visible)) {
-        IItem item = ConstrainedValue.GetValue(run, constraintColumn);
-        if (!base.Check(item))
-          run.Visible = false;
-      }
-      return true;
-    }
-
-    public override string ToString() {
-      string s = string.Empty;
-      IStringConvertibleMatrix matrix = ConstrainedValue;
-      if (matrix != null && matrix.ColumnNames.Count() != 0)
-        s += matrix.ColumnNames.ElementAt(constraintColumn) + " ";
-      else
-        return "EqualityConstraint";
-
-      if (ConstraintOperation != null)
-        s += ConstraintOperation.ToString() + " ";
-
-      if (!string.IsNullOrEmpty(ConstraintData))
-        s += ConstraintData;
-      else
-        s += "null";
-
-      return s;
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Optimization/3.3/RunCollectionTypeCompatiblityConstraint.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionTypeCompatiblityConstraint.cs	(revision 3618)
+++ 	(revision )
@@ -1,116 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Optimization {
-  [StorableClass]
-  [Item("RunCollectionTypeCompatibilityConstraint", "A constraint which checks the members of the contained runs for type compabitiliby to the constraint data.")]
-  public class RunCollectionTypeCompatibilityConstraint : TypeCompatibilityConstraint, IRunCollectionConstraint {
-    public RunCollectionTypeCompatibilityConstraint()
-      : base() {
-    }
-    [StorableConstructor]
-    protected RunCollectionTypeCompatibilityConstraint(bool deserializing) {
-    }
-    public RunCollectionTypeCompatibilityConstraint(RunCollection constrainedValue, ConstraintOperation constraintOperation, Type constraintData)
-      : base(constrainedValue, constraintOperation, constraintData) {
-    }
-    public RunCollectionTypeCompatibilityConstraint(RunCollection constrainedValue, ConstraintOperation constraintOperation, Type constraintData, bool active)
-      : base(constrainedValue, constraintOperation, constraintData, active) {
-    }
-
-    public new RunCollection ConstrainedValue {
-      get { return (RunCollection)base.ConstrainedValue; }
-      set { base.ConstrainedValue = value; }
-    }
-    [Storable]
-    private int constraintColumn;
-    public int ConstraintColumn {
-      get { return constraintColumn; }
-      set {
-        if (value < 0 || value >= ((IStringConvertibleMatrix)ConstrainedValue).ColumnNames.Count())
-          throw new ArgumentException("Could not set ConstraintData to not existing column index.");
-        if (constraintColumn != value) {
-          constraintColumn = value;
-          this.OnConstraintColumnChanged();
-        }
-      }
-    }
-
-    public event EventHandler ConstraintColumnChanged;
-    protected virtual void OnConstraintColumnChanged() {
-      EventHandler handler = ConstraintColumnChanged;
-      if (handler != null)
-        handler(this, EventArgs.Empty);
-    }
-
-    protected override bool Check(object constrainedMember) {
-      if (!Active)
-        return true;
-
-      foreach (IRun run in ConstrainedValue.Where(r => r.Visible)) {
-        IItem item = ConstrainedValue.GetValue(run, constraintColumn);
-        if (item == null || !base.Check(item))
-          run.Visible = false;
-      }
-      return true;
-    }
-
-    protected override bool Check(object constrainedMember, out string errorMessage) {
-      errorMessage = string.Empty;
-      if (!Active)
-        return true;
-
-      foreach (IRun run in ConstrainedValue.Where(r => r.Visible)) {
-        IItem item = ConstrainedValue.GetValue(run, constraintColumn);
-        if (!base.Check(item))
-          run.Visible = false;
-      }
-      return true;
-    }
-
-    public override string ToString() {
-      string s = string.Empty;
-      IStringConvertibleMatrix matrix = ConstrainedValue;
-      if (matrix != null && matrix.ColumnNames.Count() != 0)
-        s += matrix.ColumnNames.ElementAt(constraintColumn) + " ";
-      else
-        return "TypeCompabitilityConstraint";
-
-      if (ConstraintOperation != null)
-        s += ConstraintOperation.ToString() + " ";
-
-      if (ConstraintData != null)
-        s += ConstraintData;
-      else
-        s += "null";
-
-      return s;
-    }
-  }
-}